/*
 * Programming in Java, Jacobs University, 2015
 *
 * This file demonstrates the use of generics and compares it to old
 * style Java code without generics and without iterable for loops.
 * The old style code may trigger warnings and or may not be accepted
 * in the future anymore by Java compilers.
 */

import java.util.List;
import java.util.Iterator;
import java.util.LinkedList;

class Generics
{
    public static void oldstyle(String[] args)
    {
	List aList = new LinkedList();
	Iterator i;
	
	for (String s: args) {
	    aList.add(0, s);
	}

	i = aList.iterator();
	while (i.hasNext()) {
	    String s = (String) i.next();
	    System.out.print(s + " ");
	}
	System.out.println();
    }

    public static void generics(String[] args)
    {
	List<String> aList = new LinkedList<String>();
	
	for (String s: args) {
	    aList.add(0, s);
	}

	for (String s: aList) {
	    System.out.print(s + " ");
	}
	System.out.println();
    }

    public static void main(String[] args)
    {
	oldstyle(args);
	generics(args);
    }
}
